#ifndef __FSDISPLAY_H
#define __FSDIPLAY_H
#include <config.h>
#include <U8x8lib.h>
#include <LiquidCrystal_I2C.h>
#include <FSSensor.h>

#if defined DHT11_SENSOR
#define DISTPOS 2
#define LAGERPOS 4
#else
#define DISTPOS 3
#define LAGERPOS 5
#endif

class display {
private:
	U8X8_SH1106_128X64_NONAME_HW_I2C *oled;
	LiquidCrystal_I2C *lcd;
        void InitDisplay();
	unsigned long timestamp;
public:
	display();
	display(U8X8_SH1106_128X64_NONAME_HW_I2C *oled_disp);
	display(LiquidCrystal_I2C *lcd_disp);
	display(U8X8_SH1106_128X64_NONAME_HW_I2C *oled_disp,LiquidCrystal_I2C *lcd_disp);
	void begin();
	void ShowMask();
#if defined ( __XTENSA__ )
	void NetConnect();
	void ConnectOK();
	void ConnectFailed();
#endif
	void UpdateDisplay(FSSensor *sensor);
};
#endif
