#ifndef _FSSENSOR_H
#define _FSSENSOR_H

#include "Arduino.h"
#include <config.h>

//since of missing c++ implementation for
//AVR we can't use dht in c++ programming
#if defined DHT11_SENSOR
#include <DHT.h>
#endif

#if defined SENS_VL53L0X
#include <Wire.h>
#include <VL53L0X.h>
#endif

class FSSensor  {
	private:
#if defined HCSR04
		int EchoPin[NUM_SENS]=ECHOPINS;
		int TrigPin[NUM_SENS]=TRIGGERPINS;
#endif
#if defined SENS_VL53L0X
		VL53L0X *tof_sens[NUM_SENS];
#endif
		float pellets;
		float distance;
		float sens[NUM_SENS];
		float temp;
		float hum;
		float lagertemp;
		unsigned long timestamp;
#if defined DHT11_SENSOR
		DHT *dht=NULL;
#endif
	public:
		FSSensor();
#if defined DHT11_SENSOR
		FSSensor(DHT *dht11);
#endif
#if defined HCSR04
		FSSensor(int Echo1, int Trig1);
#if defined DHT11_SENSOR
		FSSensor(int Echo1, int Trig1,DHT *dht11);
		FSSensor(int Echo1, int Trig1, int Echo2, int Trig2, DHT *dht11);
#endif
		FSSensor(int Echo1, int Trig1, int Echo2, int Trig2);
#endif
		void begin();
#if defined SENS_VL53L0X
		void SelectSensor(int SenNr);
		float SensKorr[4] = { KORRSENS1, KORRSENS2, KORRSENS3, KORRSENS4 }; 
#endif
		void ReadSensor(int SenNr);
		void Calc();
		float GetDistance();
		float GetPellets();
		float GetSens(int nr);
		unsigned long GetLastUpdate();
#if defined DHT11_SENSOR
		float GetTemperature();
		float GetHumidity();
#endif
};

#endif /* _FSSENSOR_H */
