//We need some math to calculate the size of the Pelletsstorage
//and with the distance between Sensor and Pellets the remaining
//amounts of pellets
#include <math.h>
#include <FSSensor.h>
#include <FSNetwork.h>
#include <FSDisplay.h>
//if you want a more accurate distance, connect a
//DHT11 Temperature Sensor to the System
//see US_Fuellstandssensor.h to enable it
#if defined DHT11_SENSOR
	//DHT_nonblocking dht(DHT11_SENSOR,DHT_TYPE_11);
	DHT dht(DHT11_SENSOR,DHT11);
#endif

#ifdef OLED
	//Now let us create the needed class for OLED Display handling
	U8X8_SH1106_128X64_NONAME_HW_I2C oled_display(/* reset=*/ U8X8_PIN_NONE);
#endif
#ifdef LCD
	//we need a class instance to handle the LCD
	LiquidCrystal_I2C lcd_display(39,16,2);
#endif

#if defined (__XTENSA__)
//Create the Service, which we use at the moment to 
//answer Web Requests (also used by the FHEM HTTPMOD module to get the data)
network net;
#endif

#ifdef OLED
#ifndef LCD
	display disp(&oled_display);
#else
	display disp(&oled_display, &lcd_display);
#endif
#endif
#ifdef LCD
	display disp(&lcd_display);
#endif
#if defined HCSR04
#if defined DHT11_SENSOR
	FSSensor sens(14,2,12,13,&dht);
#else
	FSSensor sens(14,2,12,13);
#endif
#endif
#if defined SENS_VL53L0X
#if defined DHT11_SENSOR
	FSSensor sens(&dht);
#else
	FSSensor sens;
#endif
#endif

long unsigned int runtime=millis();
//here (it's arduino IDE!) we do all the initializing
void setup() {
	disp.begin();
#if defined ( __XTENSA__ )
	disp.NetConnect();
	net.begin();
	disp.ConnectOK();
#endif
	sens.begin();
	disp.ShowMask();
}

void loop() {
	if ( millis() > ( sens.GetLastUpdate() + ( REFRESHRATE * 1000) ) ) {
		//sens.update();
		for ( int SensNr=0; SensNr<NUM_SENS; SensNr++) {
			sens.ReadSensor(SensNr);
#if defined ( __XTENSA__ )
			net.handleWeb(&sens);
			net.handleOTA();
#endif
		}
#if defined ( __XTENSA__ )
		net.StoreTimeLastRead();
#endif
		sens.Calc();
		disp.UpdateDisplay(&sens);
	}
#if defined ( __XTENSA__ )
	net.testNet();
	net.handleWeb(&sens);
	net.handleOTA();
#endif
	yield();
}

