#ifndef _CONFIG_H
#define _CONFIG_H

//NTP Time Server Setup
//#define MY_NTP_SERVER "at.pool.ntp.org"
#define MY_NTP_SERVER "ladon.compuextreme.de"
#define MY_TZ "CET-1CEST,M3.5.0,M10.5.0/3"
//#define DEBUG
#define VERS "v87"
//if using a DHT11 Temperatur sensor
//for more accurate sonic speed
#define DHT11_SENSOR 0
#ifdef DHT11_SENSOR
#define TEMP_OFFSET -8
#endif
//#define DHT11_SENSOR 16

//If using a Ultrasonic sensor type HC-SR 04 define this
#define HCSR04
//If using a ToF Sensor (VL53L0X)
//This is only supported when using ESP8266!
//#define SENS_VL53L0X

//You can set you own headline here
//#define HEADLINE "Haralds Pellets "
#define HEADLINE "Lager Schaetzer"
/*the delivered website use a refresh heade
 * define the duration (in seconds) between each refresh*/
#define WEBREFRESH 30
		
//Rate to update the data in seconds
//#define REFRESHRATE 10
#define REFRESHRATE 10

#ifdef HCSR04
#if defined ( __XTENSA__ )
//define the pins for the Trigger signal for ESP8266
#define TRIGGERPINS { 2, 13 }
//define the pins for the ECHO Signal
#define ECHOPINS { 14, 12 }
#elif defined ( __AVR__ )
//define the pins for the Trigger signal for Arduino
#define TRIGGERPINS { 2, 4 }
#define ECHOPINS { 1, 3 }
#endif
//Die software macht mehrere messungen
//und versucht nur die höchsten Werte zu nehmen
//Anzahl dieser Messungen wird hier definiert
#define NR_MESSURE 20
#endif
//Wenn der ToF verwendet wird,
//und davon mehrere, müssen diese per MUX Chip(74HC4053) umgeschaltet werden
//PIN mit dem das passieren soll wird hier definiert
#ifdef SENS_VL53L0X
#define MUX_PIN 13
#define MUX_PIN2 15
#define KORRSENS1 1.04268292682926829268
#define KORRSENS2 1.03902439024390243902
#define KORRSENS3 1.03414634146341463414
#define KORRSENS4 1.02439024390243902439
#define NR_MESSURE 5
#endif
//we can use up to 4 sensors.
//HCSR04 -> Maximum of Sensors are 2
//VL53L0x used with 74hc4052 ca use up to 4
//define the number of really attached sensors
#define NUM_SENS 2
//Der Sensor kann wahlweise mit einem OLED Display
//oder LCD Display's konfiguriert werden.
//Beides Gleichzeitig ist NICHT möglich!
#define OLED 
//#define LCD 

//Auf dem OLED Display können verschiedene Fonts
//verwendet werden - definition im include zum
//entsprechenden OLED
#ifdef OLED
#define showfont u8x8_font_7x14_1x2_r
#define bigfont u8x8_font_8x13B_1x2_f
#endif

#define SENSHIGH 0.02
#define KHOEHE 1.85 - SENSHIGH
//#define BREITE 2.253
#define BREITE 2.16
#define LAENGE 3.00
#define WINKEL 45.00
#define PELLETSGEWICHT 0.65
//#define WANNENBODEN 0.853
#define WANNENBODEN 0.843
#define BODENHOEHE 0.04
#define SCHRAEGBREITE (BREITE-WANNENBODEN)/2

/*change the SSID Name for device AP WLAN Configuration*/
#define APSID ConfigPelletsSensor

#endif
